/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
#include <string.h>
class Date
 { public:
     Date (int = 1, int = 1, int = 1900);
     void print () const;
   private:
     int month; int day; int year;
     int checkDay (int);
 } ;
Date::Date (int d, int m, int y)
 { if (m > 0 && m <=12) month = m;
   else { month = 1;
            cout << " " << m << "  !    1!"
                    << endl;
          }
   year = y;
   day = checkDay (d);
   cout << "   Date ";
   print (); cout << endl;
 }
int Date::checkDay (int testday)
 { static int dayspermonth [13] = { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30,
               31, 30, 31} ;
   if (testday > 0 && testday <= dayspermonth [month])
    { return testday; }
   if (month == 2 && testday == 29 && ( year % 400 == 0 ||
      ( year % 4 == 0 && year % 100 != 0))) return testday;
   cout << " " << testday << "  !    1!"
           << endl;
   return 1;
 }
void Date::print () const
 { cout << day << '/' << month << '/' << year; }

class Employee
{ public:
   Employee (char *, char *, int, int, int, int, int, int);
   void print() const;
  private:
    char firstname[25];
    char lastname[25];
    Date birthdate;
    Date hiredate;
} ;
Employee::Employee (char *fname, char *lname, int bday, int bmonth, int byear, int hday, int hmonth, int hyear) : birthdate (bday, bmonth, byear), hiredate (hday, hmonth, hyear)
//  ,      //   
{ int length = strlen (fname);
  length = (length < 25) ? length : 24;
  strncpy (firstname, fname, length);
  firstname[length] = '\0';
  length = strlen (lname);
  length = (length < 25) ? length : 24;
  strncpy (lastname, lname, length);
  lastname[length] = '\0';
  cout << "   Employee: " << firstname << ' '
          << lastname << endl;
}
void Employee::print () const
 { cout << lastname << ", " << firstname << endl
           << "  : ";
   hiredate.print ();
   cout << "  : ";
   birthdate.print ();
   cout << endl;
 };
void main ()
 { Employee e ("", "", 24, 7, 49, 12, 3, 88);
   e.print ();
   Date d (35, 14, 94);
   d.print ();
 }

