/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
class Time
 { public:
     Time (int = 0, int = 0, int = 0);
     Time& setTime (int, int, int);
     Time& setHour (int);
     Time& setMinute (int);
     Time& setSecond (int);
     int getHour () const;
     int getMinute () const;
     int getSecond () const;
     void printMilitary () const;
     void printStandard () const;
  private:
     int hour;
     int minute;
     int second;
 } ;
Time::Time ( int h, int m, int s)
 { setTime (h, m, s); }
Time& Time::setTime (int h, int m, int s)
 { hour = (h>=0 && h < 24) ? h : 0;
   minute = (m>=0 && m < 60) ? m : 0;
   second = (s>=0 && s < 60) ? s : 0;
   return *this;
 }
Time& Time::setHour (int h)
 { hour = (h>=0 && h < 24) ? h : 0;
   return *this;
 }
Time& Time::setMinute (int m)
 { minute = (m>=0 && m < 60) ? m : 0;
   return *this;
 }
Time& Time::setSecond (int s)
 { second = (s>=0 && s < 60) ? s : 0;
   return *this;
 }
int Time::getHour () const { return hour; }
int Time::getMinute () const { return minute; }
int Time::getSecond () const { return second; }
void Time::printMilitary () const
 { cout << (hour<10 ? "0" : "") << hour << ":"
	 << (minute<10 ? "0" : "") << minute << ":"
	 << (second<10 ? "0" : "") << second
    << endl;
 }
void Time::printStandard () const
 { cout << ( (hour==0 || hour ==12) ? 12 : hour % 12) << ":"
    << (minute<10 ? "0" : "") << minute << ":"
	 << (second<10 ? "0" : "") << second << ((hour < 12) ? " AM" : " PM")
    << endl;
 }
void main ()
 { Time t;
   t.setHour (18).setMinute (30).setSecond (22);
   // '.'  -
   t.printMilitary ();
   t.setTime (20, 20, 20).printStandard ();
 }

