/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
class Date
{ friend ostream &operator<< (ostream &, const Date &);
  public:
    Date (int = 1, int = 1, int = 1900);
    void setDate (int, int, int);
    Date operator++ ();
    Date operator++ (int);
    const Date &operator+= (int);
    int leapYear ();
    int endofMonth ();
  private:
    int day; int month; int year;
    static int days[]; void helpIncrement ();
 } ;
int Date::days[] = { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31} ;
Date::Date (int d, int m, int y)
 { setDate (d, m, y); }
void Date::setDate (int d, int m, int y)
 { month = (m>=1 && m <=12) ? m : 1;
   year = (y >= 1900 && y <=2100) ? y : 1900;
   if (month == 2 && leapYear())
    day = (d >= 1 && d <= 29) ? d : 1;
   else day = (d >= 1 && d <= days[month]) ? d : 1;
 }
Date Date::operator++ ()
 { helpIncrement ();
   return *this; //        
 }
Date Date::operator++ (int f)
 { Date temp = *this;
   helpIncrement ();
   return temp;
 }
const Date &Date::operator+= (int addDays)
 { for (int i = 1; i <= addDays; i++)
    helpIncrement ();
   return *this; // 
 }
int Date::leapYear ()
 { if (year % 400 == 0 || (year % 100 != 0 && year % 4 == 0))
    return 1;
   return 0;
 }
int Date::endofMonth ()
 { if (month == 2 && leapYear ())
    return day == 29;
   return day == days[month];
 }
void Date::helpIncrement ()
 { if (endofMonth () && month == 12)
    { day = month = 1; year++; }
   else if (endofMonth())
    { day = 1; month++; }
   else day++;
 }
ostream &operator<< (ostream &output, const Date &d)
 { static char *monthName[13] = { "", "", "", "",    
     "", "", "", "", "", "", "",    
     "", "" } ;
   output << d.day << ' ' << monthName[d.month] << ", " << d.year;
   return output;
 }
void main ()
 { Date d1, d2 (27, 12, 1992), d3 (0, 99, 8045);
   cout << d1 << endl << d2 << endl << d3 << endl;
   cout << (d2+=7) << endl; 
   d3.setDate (28, 2, 1992);
   cout << ++d3 << endl;
   Date d4 (18, 3, 1969);
   cout << ++d4 << endl << d4 << endl;
   cout << d4++ << endl << d4 << endl;
 }

