/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
#include <iomanip.h>
class Point
 { friend ostream &operator<< (ostream &, const Point &);
   public:
     Point (float = 0.0, float = 0.0);
     void setPoint (float, float);
     float getX () const { return x; }
     float getY () const { return y; }
   protected:
     float x, y;
 } ;
Point::Point (float a, float b)
 { setPoint (a, b); }
void Point::setPoint (float a, float b)
 {  x = a; y = b; }
ostream &operator<< (ostream &output, const Point &p)
 {  output << '[' << p.x << ", " << p.y << ']';
    return output;
 }
class Circle:public Point
// Circle    Point;  ':'   
//,   public    
 {
   friend ostream &operator<< (ostream &, const Circle &);
   public:
     Circle (float = 0.0, float = 0.0, float = 0.0);
     void setRadius (float);
     float getRadius () const;
     float area () const;
   protected:
     float radius;
 } ;
Circle::Circle (float r, float a, float b) : Point (a, b)
 { radius = r; }
void Circle::setRadius (float r)
 { radius = r; }
float Circle::getRadius () const
 { return radius; }
float Circle::area () const
 { return 3.14159*radius*radius; }
ostream &operator<< (ostream &output, const Circle &c)
 { output << " = [" << c.x << ", " << c.y << "];  = "
              << setiosflags (ios::showpoint) << setprecision (2) << c.radius;
   return output;
 }
void main ()
{ Point *pointPtr, p (3.5, 5.3);
  Circle *circlePtr, c (2.7, 1.2, 8.9);
  cout << p << endl << c << endl;
  pointPtr = &c;
  cout << *pointPtr << endl;
  circlePtr = (Circle *) pointPtr;
  cout << *circlePtr << endl;
  cout << " = " << circlePtr->area () << endl;
  pointPtr = &p;
  circlePtr = (Circle *) pointPtr;
  cout << *circlePtr << endl << " = " << circlePtr->area () << endl;
}

