/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
class Base1 {
  public:
      Base1 (int x) { value = x; }
      int getData () const { return value; }
  protected:
      int value;
} ;
class Base2 {
 public:
     Base2 (char c) { letter = c; }
     char getData() const { return letter;}
 protected:
     char letter;
} ;
class Derived: public Base1, public Base2
{ friend ostream& operator<< (ostream &, const Derived &);
  public:
      Derived (int, char, float);
      float getReal () const;
  private:
      float real;
} ;
Derived::Derived ( int i, char c, float f) : Base1 (i), Base2 (c)
 { real = f; }
float Derived::getReal () const
 { return real; }
ostream& operator<< (ostream &output, const Derived &d)
 {  output << ": " << d.value << endl
               << ": " << d.letter << endl
               << ": " << d.real << endl;
    return output;
 }
void main ()
 { Base1 b1(10), *b1Ptr; Base2 b2 ('z'), *b2Ptr;
   Derived d (7, 'A', 3.5);
   cout << b1.getData() << endl
           << b2.getData() << endl
           << d << endl;
   cout << d.Base1::getData() << endl
           << d.Base2::getData() << endl
           << d.getReal() << endl;
   b1Ptr = &d;
   cout << b1Ptr -> getData() << endl;
   b2Ptr = &d;
   cout << b2Ptr -> getData() << endl;
 }
