/* Zaglaven fail kum programa ot lekciite po SDP
na doc. Buchvarov napisana ot men, Ivan Dimitrov Georgiev
(veche zavurshil) student po informatika, e-mailut mi e
ivandg@yahoo.com
*/
#ifndef CIRCLELIST_H
#define CIRCLELIST_H
#include <iostream>
template <class T>
struct Elem {
 T info;
 Elem <T> *link;
} ;
template <class T>
class CircleList {
 public:
   CircleList ();
   ~CircleList ();
   void insert (const T&);
   bool remove (T&);
 private:
   Elem <T> *ptr;
} ;
template <class T>
CircleList<T>::CircleList ()
 { ptr = NULL; }
template <class T>
CircleList<T>::~CircleList ()
 { if (ptr == NULL) return;
   Elem <T> *first = ptr -> link;
   ptr -> link = NULL;
   while (first != NULL)
    { ptr = first;
      first = first -> link;
      delete ptr;
    }
 }
template <class T>
void CircleList<T>::insert (const T& value)
 { Elem <T> *newel = new Elem <T>;
   newel -> info = value;
   if (ptr != NULL) newel -> link = ptr -> link;
   else ptr = newel;
   ptr -> link = newel;
 }
template <class T>
bool CircleList<T>::remove (T& value)
 { if (ptr == NULL) return false;
   value = ptr -> link -> info;
   Elem <T> *first = ptr -> link;
   if (ptr == first) ptr = NULL;
  else ptr -> link = first -> link;
  delete first;
  return true;
 }
#endif
