/* Programa kum tretiq proekt po teoriq na kodiraneto 
napisana ot men, Ivan Dimitrov Georgiev
(veche zavurshil) student po informatika, e-mailut mi e
ivandg@yahoo.com
*/
#include <stdio.h>
#include <string.h>
int generator[20];
int n, k, brused;
bool usedp[20], words[65536];
int code[1100000], cleader;
int m, current;
void gen (int s)
 { if (s==k+1) { code[++m] = current; return; }
   gen (s+1); 
   current = current ^ generator[s];
   gen (s+1);
   current = current ^ generator[s];
 }
void gencode ()
 { m = current = 0;
   gen (1);
 }
void printb (int k)
 { int mask = 1 << (n-1), i;
   for (i = 1; i <= n; i++)
    { if (k & mask) printf ("1"); else printf ("0");
      mask >>= 1;
    }
 }
int wei (int k)
 { int mask = 1 << (n-1), i, res = 0;
   for (i = 1; i <= n; i++)
    { if (k & mask) res++;
      mask >>= 1;
    }
   return res;
 }
void genleaders (int w)
 { int i,j;
   if (w == 0) {
      if (!words[cleader])
        { int weight = wei (cleader);
          printf ("Leaders: ");
          //cyclic shifts
          for (i = 0; i <= n-1; i++)
           { if (words[cleader]) continue;
             for (j = 1; j <= m; j++) {
               if (wei(code[j] ^ cleader) == weight && i==0)
                { printb (code[j] ^ cleader);
                  printf (" ");
                }
               words[code[j] ^ cleader] = 1;
               brused++;
             }
             cleader <<= 1;
             if (cleader & (1 << n)) { cleader = cleader | 1; cleader = cleader ^ (1 << n); }
           }
         getchar();
         printf ("\n");
        }
      return;
   }
   for (i = n-1; i >= 0; i--)
     if (!usedp[i])
      { usedp[i] = 1;
        cleader = cleader | (1 << (n-i-1));
        genleaders (w-1);
        cleader = cleader ^ (1 << (n-i-1));
        usedp[i] = 0;
      }
 }
void gencoclasses ()
 { int i;
   memset (words, 0, sizeof (words));
   brused = 0;
   for (i = 0;;i++)
    { cleader = 0;
      if (brused == (1 << n)) break;
      memset (usedp, 0, sizeof (usedp));
      genleaders(i); 
    }
 }
void init ()
 { int i, j;
   FILE *f = fopen ("gener.inp","r");
   fscanf (f, "%d%d", &n, &k);
   for (i = 1; i <= k; i++) {
     generator[i] = 0;
     for (j = 1; j <= n; j++)
       { char c;
         do { c = fgetc (f); } while (c!='0' && c!='1');
         generator[i] <<= 1;
         if (c=='1') generator[i]++;
       }
    }
   fclose (f);
 }
void main ()
 { init ();
   gencode();
   gencoclasses();
 }