/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
#include <iomanip.h>
class SalesPerson
 { public:
     SalesPerson ();
     void SetSales (int, double);
     void PrintAnnualSales ();
   private:
     double Sales[12];
     double TotalAnnualSales ();
  };
SalesPerson::SalesPerson ()
 { for (int i = 0; i < 12; i++)
    Sales[i] = 0;
 }
void SalesPerson::SetSales ( int month, double amount)
 { if (month>=1 && month <=12 && amount > 0)
    Sales [month-1] = amount;
   else cout << "!" << endl;
 }
double SalesPerson::TotalAnnualSales ()
 { double total = 0;
   for (int i = 0; i < 12; i++)
    total += Sales[i];
   return total;
 }
void SalesPerson::PrintAnnualSales ()
 { cout << setprecision (2)
	 << setiosflags (ios::fixed | ios::showpoint)
 	 << "  : $"
	 << TotalAnnualSales() << endl;
 }
void main ()
 { SalesPerson S;
   double SalesFigure;
   for (int i = 1; i <=12; i++)
    { cout << "    " << i << ": ";
      cin >> SalesFigure;
      S.SetSales (i, SalesFigure);
    }
   S.PrintAnnualSales();
 }
 
