/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
class Time
 { public:
     Time (int = 0, int = 0, int = 0);
     void setTime (int, int, int);
     void printMilitary ();
     void printStandard ();
   private:
     int hour;
     int minute;
     int second;
  };
Time::Time (int hr, int min, int sec)
 { setTime (hr, min, sec); }
void Time::setTime (int h, int m, int s)
 { hour = (h >=0 && h < 24) ? h : 0;
   minute = (m>=0 && m < 60) ? m : 0;
   second = (s>=0 && s < 60) ? s : 0;
  }
void Time::printMilitary()
 { cout << (hour<10 ? "0" : "") << hour << ":"
	 << (minute<10 ? "0" : "") << minute << ":"
	 << (second<10 ? "0" : "") << second
    << endl; }
void Time::printStandard ()
 { cout << ( (hour==0 || hour ==12) ? 12 : hour % 12) << ":"
    << (minute<10 ? "0" : "") << minute << ":"
	 << (second<10 ? "0" : "") << second << ((hour < 12) ? " AM" : " PM")
    << endl;
  }
void main ()
 { Time t1, t2 (2), t3 (21, 34), t4 (12, 25, 42), t5 (27, 74, 99);
   //  t1     ;
   t1.printMilitary ();    // 00:00:00
   t2.printMilitary ();    //  02:00:00
   t3.printMilitary ();    //  21:34:00
   t4.printStandard (); // 12:25:42 PM
   t5.printStandard (); // 12:00:00 AM
 }
 
