/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
class Time
 { public:
     Time (int = 0, int = 0, int = 0);
     void setTime (int, int, int);
     void setHour (int);
     void setMinute (int);
     void setSecond (int);
     int getHour () const;
     int getMinute () const;
     int getSecond () const;
     void printMilitary () const;
     void printStandard () const;
  private:
     int hour;
     int minute;
     int second;
 };
Time::Time (int hr, int min, int sec)
 { setTime (hr, min, sec); }
void Time::setTime (int h, int m, int s)
 { hour = (h >=0 && h < 24) ? h : 0;
   minute = (m>=0 && m < 60) ? m : 0;
   second = (s>=0 && s < 60) ? s : 0;
  }
void Time::setHour (int h)
 { hour = (h>=0 && h < 24) ? h : 0; }
void Time::setMinute (int m)
 { minute = (m>=0 && m < 60) ? m : 0; }
void Time::setSecond (int s)
 { second = (s>=0 && s < 60) ? s : 0; }
int Time::getHour () const { return hour; }
int Time::getMinute () const { return minute; }
int Time::getSecond () const { return second; }
void Time::printMilitary () const
 { cout << (hour<10 ? "0" : "") << hour << ":"
	 << (minute<10 ? "0" : "") << minute << ":"
	 << (second<10 ? "0" : "") << second
    << endl;
 }
void Time::printStandard () const
 { cout << ( (hour==0 || hour ==12) ? 12 : hour % 12) << ":"
    << (minute<10 ? "0" : "") << minute << ":"
	 << (second<10 ? "0" : "") << second << ((hour < 12) ? " AM" : " PM")
    << endl;
 }
void main ()
 { const Time t (19, 33, 52);
   t.setHour (12); //,     Borland C++
   t.setMinute (20); //,     Borland C++
   t.setSecond (39); //,     Borland C++
 }
