/*
Programa kum lekciite po OOP na doc. Buchvarov
Napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student po informatika, e-mail ivandg@yahoo.com
*/
#include <iostream.h>
#include <assert.h> //    assert
#include <string.h>
class Employee
 { public:
    Employee (const char *, const char *);
    ~Employee ();
    const char *getFirstName () const;
    const char *getLastName () const;
    static int getCount (); //    
   private:
    char *firstName; char *lastName; static int count;
 } ;
int Employee::count = 0;
//          
int Employee::getCount () { return count;}
Employee::Employee (const char *first, const char *last)
 { firstName = new char [strlen(first) + 1];
   assert (firstName != NULL);
   strcpy (firstName, first);
   lastName = new char [strlen(last) + 1];
   assert (lastName != NULL);
   strcpy (lastName, last);
   count++;
   cout << " Employee  " << firstName << ' '
 << lastName << endl;
 }
Employee::~Employee ()
 { cout << " Employee  " << firstName << ' '
           << lastName << endl;
   delete []firstName;
   delete []lastName;
   count--;
 }
const char *Employee::getFirstName () const { return firstName;}
const char *Employee::getLastName () const { return lastName;}
//    ,    
//      ;
void main ()
 { cout << Employee::getCount () << endl;
   Employee *e1ptr = new Employee ("", "");
   Employee *e2ptr = new Employee ("", "");
   cout << e1ptr->getCount() << endl;
   cout << e1ptr->getFirstName() << ' ' << e1ptr->getLastName() << endl;
 }

