/* Zaglaven fail kum programa ot lekciite po SDP
na doc. Buchvarov napisana ot men, Ivan Dimitrov Georgiev
(veche zavurshil) student po informatika, e-mailut mi e
ivandg@yahoo.com
*/
#ifndef STACK2_H
#define STACK2_H
template <class T>
struct item {
 T value;
 item *next;
} ;
template <class T>
class Stack {
 public:
   Stack ();
   ~Stack ();
   void push (const T&);
   bool pop (T&);
   T top () const;
   bool isEmpty () const;
 private:
   item <T> *first;
} ;
template <class T>
Stack <T>::Stack () : first (NULL) { }
template <class T>
Stack <T>::~Stack ()
 { item <T> *ptr;
   while (first)
     { ptr = first;
       first = first -> next;
       delete ptr;
     }
  }
template <class T>
void Stack <T>::push (const T&x)
 { item <T> *ptr = new item <T>;
   //,          
   //  new       
   //      
   ptr -> value = x;
   ptr -> next = first;
   first = ptr;
 }
template <class T>
bool Stack <T>::pop (T &x)
 { if (isEmpty()) return false;
   item <T> *ptr = first;
   first = first -> next;
   x = ptr -> value;
   delete ptr;
   return true;
 }
template <class T>
T Stack <T>::top () const
 { return first -> value; } 
//,   top       
template <class T>
bool Stack <T>::isEmpty () const
 { return first==NULL; }
#endif
