/* Programa kum vtoriq proekt po chisleni metodi-praktikum,
napisana ot men, Ivan Dimitrov Georgiev (veche zavurshil) student
po informatika, e-mailut mi e ivandg@yahoo.com
*/
#include <stdio.h>
#include <math.h>
double G1 (double x)
 { return sqrt(x+2);
 }
double G2 (double x)
 { return 0.2*sin(x) + 0.5;
 }
double G3 (double x)
 { return 0.1 + tan (x) - 0.5*x; }
double fixpnt (double G(double x), double x0, double xtol, int ntol, int& iflag)
 { double x1 = x0, x2 = G (x1); int n = 1;
   while (n <= ntol)
     { printf ("%d %.10lf\n",n, x2);
       if (fabs(x1-x2) < xtol) break;
       x1 = x2;
       x2 = G (x2);
       n++;
     }
   if (ntol > n) iflag = 1; else iflag = 0;
   return x2;
 }
double steff (double G(double x), double y0, double xtol, int ntol, int& iflag)
 { double x0,x1,x2=y0; int n = 1;
   while (n <= ntol)
    { x0 = G (x2); x1 = G (x0);
      x2 = x1 - ((x1-x0)*(x1-x0))/(x1-2*x0+x2);
      printf ("%d %.10lf\n", n, x2);
      if (fabs(x1-x2) < xtol) break;
      n++;
    }
   if (ntol > n) iflag = 1; else iflag = 0;
   return x2;
 }
void main ()
 { int iflag; double res;
   printf ("Namirane na koren na x^2-x-2 = 0\n");
   printf ("Nachalno priblijenie x = 10, iterirashta funkcia sqrt(2+x)\n");
   res = fixpnt (G1, 10, 0.0000001, 50, iflag);
   if (iflag!=0) printf ("Korenut s tochnost 10^-6 e: %.6lf\n", res);
   else printf ("Napraveni sa poveche ot 50 stupki!\n");
   getchar();
   printf ("Namirane na koren na x - 0.2*sin x - 0.5 = 0\n");
   printf ("Nachalno priblijenie x = -0.5, iterirashta funkcia 0.2*sin x + 0.5\n");
   res = fixpnt (G2, -0.5, 0.0000001, 50, iflag);
   if (iflag!=0) printf ("Korenut s tochnost 10^-6 e: %.6lf\n", res);
   else printf ("Napraveni sa poveche ot 50 stupki!\n");
   getchar();
   printf ("Namirane na koren na 1.5*x - tg x = 0.1\n");
   printf ("Nachalno priblijenie x = 0, iterirashta funkcia 0.1 + tg x + 0.5*x\n");
   res = fixpnt (G3, 0, 0.0000001, 50, iflag);
   if (iflag!=0) printf ("Korenut s tochnost 10^-6 e: %.6lf\n", res);
   else printf ("Napraveni sa poveche ot 50 stupki!\n");
   getchar();
   printf ("Metod na Stefanson\n");
   printf ("Namirane na koren na x^2-x-2 = 0\n");
   printf ("Nachalno priblijenie x = 10, iterirashta funkcia sqrt(2+x)\n");
   res = steff (G1, 10, 0.0000001, 20, iflag);
   if (iflag!=0) printf ("Korenut s tochnost 10^-6 e: %.6lf\n", res);
   else printf ("Napraveni sa poveche ot 20 stupki!\n");
   getchar();
   printf ("Metod na Stefanson\n");
   printf ("Namirane na koren na x - 0.2*sin x - 0.5 = 0\n");
   printf ("Nachalno priblijenie x = -0.5, iterirashta funkcia 0.2*sin x + 0.5\n");
   res = steff (G2, -0.5, 0.0000001, 20, iflag);
   if (iflag!=0) printf ("Korenut s tochnost 10^-6 e: %.6lf\n", res);
   else printf ("Napraveni sa poveche ot 20 stupki!\n");
   getchar();
   printf ("Metod na Stefanson\n");
   printf ("Namirane na koren na 1.5*x - tg x = 0.1\n");
   printf ("Nachalno priblijenie x = 0, iterirashta funkcia 0.1 + tg x + 0.5*x\n");
   res = steff (G3, 0, 0.0000001, 20, iflag);
   if (iflag!=0) printf ("Korenut s tochnost 10^-6 e: %.6lf\n", res);
   else printf ("Napraveni sa poveche ot 20 stupki!\n");
   getchar();
 }

