#include <stdio.h>
#define N 12
struct node {
   unsigned num;
   unsigned count;
   node *next;
   } *list; //list of the different perm elements with their counts
            //the list has fictional element in its top to make deletion
            //universal
unsigned fact[13]; //precomputing factorials
unsigned alln; //total number of elements
unsigned diffn; //total number of different elements
unsigned p; //number of searched perm
unsigned answer[N];
/*********************************/
//adding element to the list (on top)
void add (unsigned num, unsigned count)
 { node *newnode = new node;
   newnode -> num = num;
   newnode -> count = count;
   newnode -> next = list -> next;
   list -> next = newnode;
 }
/*********************************/
//deleting element from a linked list (after a given element)
void del (node *l)
 { node *save = l -> next;
   l -> next = l -> next -> next;
   delete save;
 }
/*********************************/
//computes answer[ind], ..., answer[alln-1] given
//lex number of the perm and total number of perms
void compute (unsigned number, unsigned all, unsigned ind)
 { if (ind == alln) return;
   node *l = list;  //used to traverse elements in list
   unsigned si, ci;
   for (si = 0; ;)
     { //compute number of perms starting with l -> next -> num
       ci = (all * l -> next -> count) / (alln - ind);
       //check if current element of perm must be l -> next -> num
       if (si <= number && number <= si + ci - 1) break;
       si += ci;
       l = l -> next;
     }
     answer[ind] = l -> next -> num;
     l -> next -> count --;
     if (l -> next -> count == 0) del (l);
     compute (number - si, ci, ind + 1); //straight recursion
 }
/*********************************/
void sort (unsigned arr[], unsigned n)
 { unsigned i, j;
   unsigned swap;
   //selection sort
   for (i = 0; i < n-1; i++)
     for (j = i+1; j < n; j++)
       if (arr[i] < arr[j])
        { swap = arr[i];
          arr[i] = arr[j];
          arr[j] = swap;
        }
 }
/*********************************/
void input ()
 { unsigned k; //number of tests
   unsigned i, j; //counters
   unsigned s; //total number of perms
   unsigned arrayall[N]; //auxiliary array for all perm elements
   node *newnode = new node; //the fictional element of list
   //precompute factorials
   fact[0] = 1;
   for (i = 1; i < 13; i++) fact[i] = i * fact[i-1];
   //add manually the fictional element to the list
   list = newnode;
   list -> next = NULL;
   FILE *fin = fopen ("perm.inp", "r");
   FILE *fout = fopen ("perm.out", "w");
   fscanf (fin, "%u", &k); //read k
   for (i = 0; i < k; i++)
     { fscanf (fin, "%u%u", &alln, &p); //read alln and p
       for (j = 0; j < alln; j++)
         fscanf (fin, "%u", arrayall+j); //read all elements
       sort (arrayall, alln); //sort the elements of the perm
       								//sort is descending, because elems enter list
                              //in reverse order
       //construct the list of different elements
       add (arrayall[0], 1); //add first element to list
       diffn = 1;
       s = fact [alln]; //number of all perms, counting every elem as different
       for (j = 1; j < alln; j++)
          if (list -> next -> num != arrayall[j])
            { s /= fact[list -> next -> count];  //correct the number of all perms
              ++diffn;
              add (arrayall[j], 1);
            }
          else list -> next -> count++;
       s /= fact[list -> next -> count]; //correct the number of all perms
       compute (p, s, 0);
       //write answer
       for (j = 0; j < alln-1; j++)
         fprintf (fout, "%u ", answer[j]);
       fprintf (fout, "%u\n", answer[alln-1]);
     }
   fclose (fin);
   fclose (fout);
 }
/*********************************/
int main () {
   input ();
   return 0;
}

